/* $Id$ */
package yukihane.jnicoapi;

/**
 *
 * @author yuki
 */
public interface ProgressListener {

    /**
     * NicoHttpClient からユーザスレッドに通知を行う際に使用されるメソッドです.
     * @param fileSize ダウンロードするファイルサイズ.
     * @param downloadSize  現在ダウンロードが完了したサイズ.
     */
    void progress(long fileSize, long downloadSize);

    /**
     * 何もしないリスナの実装.
     */
    static final ProgressListener EMPTY_LISTENER = new ProgressListener() {

        @Override
        public void progress(long fileSize, long downloadSize) {
        }
    };
}
